#include <stdio.h>
#include <gtk/gtk.h>
#include "patch.h"
#include "gui.h"
#include "specimen.h"

static GtkWidget*     window;
static GtkWidget*     time_spin;
static GtkWidget*     porta_check;
static GtkAdjustment* time_adj;

static int curpatch = -1;

static void cb_porta (GtkWidget* widget, gpointer data)
{
     if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (porta_check)))
     {
	  gtk_widget_set_sensitive (time_spin, TRUE);
	  patch_set_portamento (curpatch, TRUE);

     }
     else
     {
	  gtk_widget_set_sensitive (time_spin, FALSE);
	  patch_set_portamento (curpatch, FALSE);
     }
}

static void cb_time (GtkWidget* widget, gpointer data)
{
     float val = (float) gtk_spin_button_get_value (GTK_SPIN_BUTTON (time_spin));

     /* WHATTHEFUCKWHATTHEFUCKWHATTHEFUCKWHYWHYWHYWHATTHEFUCKISWRONGWITHYOUMOTHERFUCKISHOULDN'THAVETOFUCKINGDOTHIS! */
     if (val < 0.000001)
	  val = 0.0;
     
     /* This is STUPID RETARDED DUMB!  How the FUCK can a number not
      * equal zero, and yet, be zero?  I explicitly cast the fucker to
      * a float, but noooooooooooooooooooooo.  And it's not like the
      * program's overoptimized or anything, it's only -02
      * motherfuckers!  WORK! BE ZERO, DAMN YOU!  I SWEAR TO GOD, IF
      * THIS BUG WAS A PERSON I WOULD KILL THEM, GRIND THEM UP INTO
      * PATTIES OF ROUGHLY EQUAL SIZE, COOK THEM, AND EAT THEM!*/
     
     patch_set_portamento_time (curpatch, val);

     /* ...assholes, I'm learning assembler... */
}

static void cb_close ( )
{
     gtk_widget_hide (window);
}

void porta_settings_show ( )
{
     float secs;
     
     if ((curpatch = get_current_patch ( )) < 0)
	  return;
     
     if (patch_get_portamento (curpatch) == TRUE)
     {
	  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (porta_check), TRUE);
     }
     else
     {
	  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (porta_check), FALSE);
     }

     if ((secs = patch_get_portamento_time (curpatch)) >= 0.0)
     {
	  gtk_spin_button_set_value (GTK_SPIN_BUTTON (time_spin), secs);
     }
     
     gtk_widget_show (window);
}

void porta_settings_init (GtkWidget* parent)
{
     GtkWidget* vbox;
     GtkWidget* hbox;
     GtkWidget* button;
     GtkWidget* label;
     GtkWidget* sep;

     /* main window */
     window = gtk_window_new      (GTK_WINDOW_TOPLEVEL);
     gtk_window_set_title         (GTK_WINDOW (window), "Portamento");
     gtk_window_set_resizable     (GTK_WINDOW (window), FALSE);
     gtk_window_set_transient_for (GTK_WINDOW (window),
				   GTK_WINDOW (parent));
     gtk_window_set_modal         (GTK_WINDOW (window), TRUE);
     g_signal_connect             (GTK_WINDOW (window), "delete-event",
				   G_CALLBACK (cb_close), NULL);

     /* vbox */
     vbox = gtk_vbox_new (FALSE, SPACING);
     gtk_container_add (GTK_CONTAINER (window), vbox);
     gtk_container_set_border_width (GTK_CONTAINER (window), SPACING);
     gtk_widget_show (vbox);

     /* hbox */
     hbox = gtk_hbox_new (FALSE, SPACING);
     gtk_box_pack_start (GTK_BOX (vbox), hbox, FALSE, FALSE, 0);
     gtk_widget_show (hbox);

     /* portamento */
     porta_check = gtk_check_button_new_with_label ("Portamento");
     gtk_box_pack_start (GTK_BOX (hbox), porta_check, FALSE, FALSE, 0);
     g_signal_connect (G_OBJECT (porta_check), "toggled",
		       G_CALLBACK (cb_porta), NULL);
     gtk_widget_show (porta_check);
     
     /* hbox */
     hbox = gtk_hbox_new (FALSE, SPACING);
     gtk_box_pack_start (GTK_BOX (vbox), hbox, FALSE, FALSE, 0);
     gtk_widget_show (hbox);

     /* time */
     label = gtk_label_new ("Time:");
     gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 0);
     gtk_widget_show (label);

     time_adj = (GtkAdjustment *) gtk_adjustment_new (0.1, 0.0, 3.0, 0.01, 0, 0);
     time_spin = gtk_spin_button_new (time_adj, 0, 2);
     g_signal_connect (G_OBJECT (time_adj), "value-changed",
		       G_CALLBACK (cb_time), NULL);
     gtk_box_pack_end (GTK_BOX (hbox), time_spin, FALSE, FALSE, 0);
     gtk_widget_show (time_spin);

     /**************/
     sep = gtk_hseparator_new ( );
     gtk_box_pack_start (GTK_BOX (vbox), sep, FALSE, FALSE, 0);
     gtk_widget_show (sep);

     /* hbox */
     hbox = gtk_hbox_new (FALSE, SPACING);
     gtk_box_pack_start (GTK_BOX (vbox), hbox, FALSE, FALSE, 0);
     gtk_widget_show (hbox);

     /* close button */
     button = gtk_button_new_from_stock (GTK_STOCK_CLOSE);
     g_signal_connect (G_OBJECT (button), "clicked", G_CALLBACK (cb_close),
		       NULL);
     gtk_box_pack_end (GTK_BOX (hbox), button, FALSE, FALSE, 0);
     gtk_widget_show (button);

     gtk_toggle_button_toggled (GTK_TOGGLE_BUTTON (porta_check));
}
